Index: LMDZ5/trunk/libf/phylmd/cva_driver.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cva_driver.F90	(revision 2006)
+++ LMDZ5/trunk/libf/phylmd/cva_driver.F90	(revision 2007)
@@ -1009,5 +1062,6 @@
     PRINT *, ' cv_compress -> '
     debut = .FALSE.
-  END IF !(debut) THEN
+  END IF  !(debut) THEN
+
 
   RETURN
Index: LMDZ5/trunk/libf/phylmd/cvltr.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cvltr.F90	(revision 2006)
+++ LMDZ5/trunk/libf/phylmd/cvltr.F90	(revision 2007)
@@ -3,5 +3,6 @@
 !
 SUBROUTINE cvltr(pdtime, da, phi,phi2,d1a,dam, mpIN,epIN, &
-           sigd,sij,clw,elij,epmlmMm,eplaMm,              &
+!!           sigd,sij,clw,elij,epmlmMm,eplaMm,              &   !RL
+           sigd,sij,wght_cvfd,clw,elij,epmlmMm,eplaMm,    &     !RL
            pmflxrIN,pmflxsIN,ev,te,wdtrainA,wdtrainM,     &
            paprs,it,tr,upd,dnd,inb,icb,                   &
@@ -47,4 +48,5 @@
   REAL,DIMENSION(klon,klev),INTENT(IN)      :: te 
   REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: sij        ! fraction dair de lenv
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: wght_cvfd  ! weights of the layers feeding convection
   REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: elij       ! contenu en eau condensée spécifique/conc deau condensée massique
   REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: epmlmMm    ! eau condensee precipitee dans mel masse dair sat
@@ -71,4 +73,5 @@
   REAL,DIMENSION(klon,klev,nbtr)    :: zmfd,zmfa
   REAL,DIMENSION(klon,klev,nbtr)    :: zmfp,zmfu
+  REAL,DIMENSION(klon,nbtr)         :: qfeed     ! tracer concentration feeding convection
 
   REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT)    :: zmfd1a
@@ -168,5 +171,5 @@
    scavtrac = 0.
    uscavtrac = 0.
-
+   qfeed(:,it) = 0.              !RL
   DO j=1,klev
    DO i=1,klon
@@ -330,9 +333,23 @@
 ! calcul des tendances liees aux courants satures   j <-> z ; k <-> z'
 ! =========================================
+!
+!RL
+!  Feeding concentrations
   DO j=1,klev
      DO i=1,klon
-        zmfa(i,j,it)=da(i,j)*(tr(i,1,it)-tr(i,j,it))                     ! da
-     END DO
-  END DO
+        qfeed(i,it)=qfeed(i,it)+wght_cvfd(i,j)*tr(i,j,it)
+     END DO
+  END DO
+!RL
+!
+  DO j=1,klev
+     DO i=1,klon
+!RL
+!!        zmfa(i,j,it)=da(i,j)*(tr(i,1,it)-tr(i,j,it))                     ! da
+        zmfa(i,j,it)=da(i,j)*(qfeed(i,it)-tr(i,j,it))                     ! da
+!RL
+     END DO
+  END DO
+!
   DO k=1,klev
      DO j=1,klev
Index: LMDZ5/trunk/libf/phylmd/cvltr_noscav.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cvltr_noscav.F90	(revision 2007)
+++ LMDZ5/trunk/libf/phylmd/cvltr_noscav.F90	(revision 2007)
@@ -0,0 +1,197 @@
+!
+! $Id $
+!
+SUBROUTINE cvltr_noscav(it,pdtime,da, phi, mp,wght_cvfd,paprs,pplay,x,upd,dnd,dx)
+  USE dimphy
+  USE infotrac, ONLY : nbtr
+  IMPLICIT NONE 
+!=====================================================================
+! Objet : convection des traceurs / KE
+! Auteurs: M-A Filiberti and J-Y Grandpeix
+!=====================================================================
+  include "YOMCST.h"
+  include "YOECUMF.h" 
+
+! Entree
+  REAL,INTENT(IN)                           :: pdtime
+  INTEGER, INTENT(IN)                       :: it
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: da
+  REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: phi
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: mp
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: wght_cvfd  ! weights of the layers feeding convection
+  REAL,DIMENSION(klon,klev+1),INTENT(IN)    :: paprs ! pression aux 1/2 couches (bas en haut)
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: pplay ! pression pour le milieu de chaque couche
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(IN)      :: x     ! q de traceur (bas en haut) 
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: upd   ! saturated updraft mass flux
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: dnd   ! saturated downdraft mass flux
+
+! Sortie
+  REAL,DIMENSION(klon,klev,nbtr),INTENT(OUT) :: dx ! tendance de traceur  (bas en haut)
+
+! Variables locales     
+! REAL,DIMENSION(klon,klev)       :: zed
+  REAL,DIMENSION(klon,klev,klev)  :: zmd
+  REAL,DIMENSION(klon,klev,klev)  :: za
+  REAL,DIMENSION(klon,klev)       :: zmfd,zmfa
+  REAL,DIMENSION(klon,klev)       :: zmfp,zmfu
+  REAL,DIMENSION(klon,nbtr)       :: qfeed     ! tracer concentration feeding convection
+  REAL,DIMENSION(klon,klev)       :: deltap
+  INTEGER                         :: i,k,j 
+  REAL                            :: pdtimeRG
+  real conserv
+  real smfd
+  real smfu
+  real smfa
+  real smfp
+! =========================================
+! calcul des tendances liees au downdraft
+! =========================================
+!cdir collapse
+  qfeed(:,it) = 0.
+  DO j=1,klev
+  DO i=1,klon
+!   zed(i,j)=0.
+    zmfd(i,j)=0.
+    zmfa(i,j)=0.
+    zmfu(i,j)=0.
+    zmfp(i,j)=0.
+  END DO
+  END DO
+!cdir collapse
+  DO k=1,klev
+  DO j=1,klev
+  DO i=1,klon
+    zmd(i,j,k)=0.
+    za (i,j,k)=0.
+  END DO
+  END DO
+  END DO
+! entrainement
+! DO k=1,klev-1
+!    DO i=1,klon
+!       zed(i,k)=max(0.,mp(i,k)-mp(i,k+1))
+!    END DO
+! END DO
+
+! calcul de la matrice d echange
+! matrice de distribution de la masse entrainee en k
+
+  DO k=1,klev-1
+     DO i=1,klon
+        zmd(i,k,k)=max(0.,mp(i,k)-mp(i,k+1))
+     END DO
+  END DO
+  DO k=2,klev
+     DO j=k-1,1,-1
+        DO i=1,klon
+           if(mp(i,j+1).ne.0) then
+              zmd(i,j,k)=zmd(i,j+1,k)*min(1.,mp(i,j)/mp(i,j+1))
+           ENDif
+        END DO
+     END DO
+  END DO
+  DO k=1,klev
+     DO j=1,klev-1
+        DO i=1,klon
+           za(i,j,k)=max(0.,zmd(i,j+1,k)-zmd(i,j,k))
+        END DO
+     END DO
+  END DO
+!
+! rajout du terme lie a l ascendance induite
+!
+  DO j=2,klev
+     DO i=1,klon
+        za(i,j,j-1)=za(i,j,j-1)+mp(i,j)
+     END DO
+  END DO
+!
+! tendances
+!            
+  DO k=1,klev
+     DO j=1,klev
+        DO i=1,klon
+           zmfd(i,j)=zmfd(i,j)+za(i,j,k)*(x(i,k,it)-x(i,j,it))
+        END DO
+     END DO
+  END DO
+!
+! =========================================
+! calcul des tendances liees aux flux satures
+! =========================================
+!RL
+!  Feeding concentrations
+  DO j=1,klev
+     DO i=1,klon
+        qfeed(i,it)=qfeed(i,it)+wght_cvfd(i,j)*x(i,j,it)
+     END DO
+  END DO
+!RL
+!
+  DO j=1,klev
+     DO i=1,klon
+!RL
+!!        zmfa(i,j,it)=da(i,j)*(x(i,1,it)-x(i,j,it))                     ! da
+        zmfa(i,j)=da(i,j)*(qfeed(i,it)-x(i,j,it))                     ! da
+!RL
+     END DO
+  END DO
+!
+!!  print *,'it, qfeed(1,it), x(1,1,it) ', it, qfeed(1,it), x(1,1,it)  !jyg
+!!  print *,'wght_cvfd ', (j, wght_cvfd(1,j), j=1,5)                     !jyg
+!
+  DO k=1,klev
+     DO j=1,klev
+        DO i=1,klon
+           zmfp(i,j)=zmfp(i,j)+phi(i,j,k)*(x(i,k,it)-x(i,j,it))
+        END DO
+     END DO
+  END DO
+  DO j=1,klev-1
+     DO i=1,klon
+        zmfu(i,j)=max(0.,upd(i,j+1)+dnd(i,j+1))*(x(i,j+1,it)-x(i,j,it))
+     END DO
+  END DO
+  DO j=2,klev
+     DO i=1,klon
+        zmfu(i,j)=zmfu(i,j)+min(0.,upd(i,j)+dnd(i,j))*(x(i,j,it)-x(i,j-1,it))
+     END DO
+  END DO
+
+! =========================================
+! calcul final des tendances
+! =========================================
+  DO k=1, klev
+     DO i=1, klon
+        deltap(i,k)=paprs(i,k)-paprs(i,k+1)
+     ENDDO
+  ENDDO
+  pdtimeRG=pdtime*RG
+!cdir collapse
+  DO k=1, klev
+     DO i=1, klon
+        dx(i,k,it)=(zmfd(i,k)+zmfu(i,k)       &
+                +zmfa(i,k)+zmfp(i,k))*pdtimeRG/deltap(i,k)
+     ENDDO
+  ENDDO
+
+!! test de conservation du traceur
+      conserv=0.
+      smfd = 0.
+      smfu = 0.
+      smfa = 0.
+      smfp = 0.
+      DO k=1, klev
+        DO i=1, klon
+         conserv=conserv+dx(i,k,it)*   &
+          deltap(i,k)/RG
+         smfd = smfd + zmfd(i,k)*pdtime
+         smfu = smfu + zmfu(i,k)*pdtime
+         smfa = smfa + zmfa(i,k)*pdtime
+         smfp = smfp + zmfp(i,k)*pdtime
+        ENDDO
+      ENDDO
+!!      print *,'it',it,'cvltr_noscav conserv, smfd, smfu, smfa, smfp ',conserv,  &
+!!               smfd, smfu, smfa, smfp
+     
+END SUBROUTINE cvltr_noscav
Index: LMDZ5/trunk/libf/phylmd/physiq.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/physiq.F90	(revision 2006)
+++ LMDZ5/trunk/libf/phylmd/physiq.F90	(revision 2007)
@@ -237,4 +237,5 @@
   ! Variables pour le transport convectif
   real da(klon,klev),phi(klon,klev,klev),mp(klon,klev)
+  real wght_cvfd(klon,klev)
   ! Variables pour le lessivage convectif
   ! RomP >>> 
@@ -2061,5 +2062,5 @@
              ftd,fqd,lalim_conv,wght_th, &
              ev, ep,epmlmMm,eplaMm, &
-             wdtrainA,wdtrainM)
+             wdtrainA,wdtrainM,wght_cvfd)
         ! RomP <<<
 
@@ -3479,5 +3480,5 @@
        pmflxr,   pmflxs,    prfl,     psfl, &
        da,       phi,       mp,       upwd, &
-       phi2,     d1a,       dam,      sij, &        !<<RomP
+       phi2,     d1a,       dam,      sij, wght_cvfd, &        !<<RomP+RL
        wdtrainA, wdtrainM,  sigd,     clw,elij, &   !<<RomP
        ev,       ep,        epmlmMm,  eplaMm, &     !<<RomP
Index: LMDZ5/trunk/libf/phylmd/phytrac_mod.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/phytrac_mod.F90	(revision 2006)
+++ LMDZ5/trunk/libf/phylmd/phytrac_mod.F90	(revision 2007)
@@ -54,27 +54,27 @@
 CONTAINS
 
-SUBROUTINE phytrac(                            &
-     nstep,     julien,   gmtime,   debutphy,  &
-     lafin,     pdtphys,  u, v,     t_seri,    &
-     paprs,     pplay,    pmfu,     pmfd,      &
-     pen_u,     pde_u,    pen_d,    pde_d,     &
-     cdragh,    coefh,    fm_therm, entr_therm,&
-     yu1,       yv1,      ftsol,    pctsrf,    &
-     ustar,     u10m,      v10m,               &
-     wstar,     ale_bl,      ale_wake,         &
-     xlat,      xlon,                          &
-     frac_impa,frac_nucl,beta_fisrt,beta_v1,   &
-     presnivs,  pphis,    pphi,     albsol,    &
-     sh,        rh,       cldfra,   rneb,      &
-     diafra,    cldliq,   itop_con, ibas_con,  &
-     pmflxr,    pmflxs,   prfl,     psfl,      &
-     da,        phi,      mp,       upwd,      &
-     phi2,      d1a,      dam,      sij,       &   ! RomP
-     wdtrainA,  wdtrainM, sigd,     clw,elij,  &   ! RomP 
-     evap,      ep,       epmlmMm,  eplaMm,    &   ! RomP
-     dnwd,      aerosol_couple,     flxmass_w, &
-     tau_aero,  piz_aero,  cg_aero, ccm,       &
-     rfname,                                   &
-     d_tr_dyn,                                 &   ! RomP
+SUBROUTINE phytrac(                                 &
+     nstep,     julien,   gmtime,   debutphy,       &
+     lafin,     pdtphys,  u, v,     t_seri,         &
+     paprs,     pplay,    pmfu,     pmfd,           &
+     pen_u,     pde_u,    pen_d,    pde_d,          &
+     cdragh,    coefh,    fm_therm, entr_therm,     &
+     yu1,       yv1,      ftsol,    pctsrf,         &
+     ustar,     u10m,      v10m,                    &
+     wstar,     ale_bl,      ale_wake,              &
+     xlat,      xlon,                               &
+     frac_impa,frac_nucl,beta_fisrt,beta_v1,        &
+     presnivs,  pphis,    pphi,     albsol,         &
+     sh,        rh,       cldfra,   rneb,           &
+     diafra,    cldliq,   itop_con, ibas_con,       &
+     pmflxr,    pmflxs,   prfl,     psfl,           &
+     da,        phi,      mp,       upwd,           &
+     phi2,      d1a,      dam,      sij, wght_cvfd, &   ! RomP +RL
+     wdtrainA,  wdtrainM, sigd,     clw, elij,      &   ! RomP 
+     evap,      ep,       epmlmMm,  eplaMm,         &   ! RomP
+     dnwd,      aerosol_couple,     flxmass_w,      &
+     tau_aero,  piz_aero,  cg_aero, ccm,            &
+     rfname,                                        &
+     d_tr_dyn,                                      &   ! RomP
      tr_seri)         
 !
@@ -190,4 +190,5 @@
   REAL,DIMENSION(klon,klev),INTENT(IN)      :: ep
   REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: sij
+  REAL,DIMENSION(klon,klev),INTENT(IN)      :: wght_cvfd          !RL
   REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: elij
   REAL,DIMENSION(klon,klev,klev),INTENT(IN) :: epmlmMm
@@ -507,5 +508,6 @@
 !
           CALL cvltr(pdtphys, da, phi,phi2,d1a,dam, mp,ep,              &
-               sigd,sij,clw,elij,epmlmMm,eplaMm,                        &
+!!               sigd,sij,clw,elij,epmlmMm,eplaMm,                        &   !RL
+               sigd,sij,wght_cvfd,clw,elij,epmlmMm,eplaMm,              &     !RL
                pmflxr,pmflxs,evap,t_seri,wdtrainA,wdtrainM,             &   
                paprs,it,tr_seri,upwd,dnwd,itop_con,ibas_con,            &
@@ -514,6 +516,8 @@
                zmfd1a,zmfphi2,zmfdam)
         else  !pas de lessivage convectif ou n'est pas un aerosol
-           CALL cvltrorig(it,pdtphys, da, phi,mp,paprs,pplay,tr_seri,&
-                    upwd,dnwd,d_tr_cv)
+!!           CALL cvltrorig(it,pdtphys, da, phi,mp,paprs,pplay,tr_seri,&      !jyg
+!!                    upwd,dnwd,d_tr_cv)                                      !jyg
+           CALL cvltr_noscav(it,pdtphys, da, phi,mp,wght_cvfd,paprs,pplay, &  !jyg
+                    tr_seri,upwd,dnwd,d_tr_cv)                                !jyg
         endif
         END IF
